<?php

// Check nonce
PHPCUS_PARAM::CUS_REQUIRES_NONCE();

// Check Array Input
PHPCUS_PARAM::CUS_DOES_NOT_SUPPORT_ARRAY();

// Check already authenticated
PHPCUS_PARAM::CUS_REQUIRES_AUTHENTICATION();
// Check access rights
PHPCUS_PARAM::CUS_HAS_PERMISSION(PHPCUS_SYSTEM::AUTHORITY_VIEW_ONLY, 'addon_resource');

if
(
    PHPRC_HTTP_PARAM::REF_ISSET_IN_ARRAY
    (
        [
            'PARAM_ADD_RESOURCE_ID',
            'PARAM_ADD_RESOURCE_GLOBAL_ID',
            'PARAM_ADD_RESOURCE_GROUP_KEY',
            'PARAM_ADD_RESOURCE_PARAMETER',
            'PARAM_ADD_RESOURCE_REMARKS',
            'PARAM_ADD_RESOURCE_STATUS',
            
            'PARAM_ORDER_FIELD',
            'PARAM_ORDER_TYPE',
            'PARAM_SKIP',
            'PARAM_LIMIT'
        ], True
        )
    )
{
    Try
    {
        // Read params
        // ------------------------------------------------------------------
        $PARAM_ADD_RESOURCE_ID = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_ADD_RESOURCE_ID');
        $PARAM_ADD_RESOURCE_GLOBAL_ID = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ADD_RESOURCE_GLOBAL_ID');
        $PARAM_ADD_RESOURCE_GROUP_KEY = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ADD_RESOURCE_GROUP_KEY');
        $PARAM_ADD_RESOURCE_PARAMETER = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ADD_RESOURCE_PARAMETER');
        $PARAM_ADD_RESOURCE_REMARKS = PHPCUS_PARAM::CUS_READ_NVARCHAR('PARAM_ADD_RESOURCE_REMARKS');
        $PARAM_ADD_RESOURCE_STATUS = PHPCUS_PARAM::CUS_READ_INT('PARAM_ADD_RESOURCE_STATUS');
        
        $PARAM_ORDER_FIELD = PHPCUS_PARAM::CUS_READ_SORT_FIELD
        (
            'PARAM_ORDER_FIELD',
            [
                'ADD_RESOURCE_ID',
                'ADD_RESOURCE_GLOBAL_ID',
                'ADD_RESOURCE_GROUP_KEY',
                'ADD_RESOURCE_VALUE',
                'ADD_RESOURCE_PARAMETER',
                'ADD_RESOURCE_REMARKS',
                'ADD_RESOURCE_STATUS'
            ]
            );
        $PARAM_ORDER_TYPE = PHPCUS_PARAM::CUS_READ_SORT_TYPE('PARAM_ORDER_TYPE');
        $PARAM_SKIP	= PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_SKIP');
        $PARAM_LIMIT = PHPCUS_PARAM::CUS_READ_BIGINT('PARAM_LIMIT');
        
        // ------------------------------------------------------------------
        
        
        // Populate Map Array
        // ...........................................
        $GET_MAP_ARRAY = PHPCUS_ADDON_RESOURCE::CUS_PREPARE_MAPPED_ARRAY_FOR_GET();
        
        $GET_MAP_ARRAY['PARAM_ADD_RESOURCE_ID'] = $PARAM_ADD_RESOURCE_ID;
        $GET_MAP_ARRAY['PARAM_ADD_RESOURCE_GLOBAL_ID'] = $PARAM_ADD_RESOURCE_GLOBAL_ID;
        $GET_MAP_ARRAY['PARAM_ADD_RESOURCE_GROUP_KEY'] = $PARAM_ADD_RESOURCE_GROUP_KEY;
        $GET_MAP_ARRAY['PARAM_ADD_RESOURCE_PARAMETER'] = $PARAM_ADD_RESOURCE_PARAMETER;
        $GET_MAP_ARRAY['PARAM_ADD_RESOURCE_REMARKS'] = $PARAM_ADD_RESOURCE_REMARKS;
        $GET_MAP_ARRAY['PARAM_ADD_RESOURCE_STATUS'] = $PARAM_ADD_RESOURCE_STATUS;
        
        $GET_MAP_ARRAY["PARAM_ORDER_FIELD"] = $PARAM_ORDER_FIELD;
        $GET_MAP_ARRAY["PARAM_ORDER_TYPE"] = $PARAM_ORDER_TYPE;
        $GET_MAP_ARRAY["PARAM_SKIP"] = $PARAM_SKIP;
        $GET_MAP_ARRAY["PARAM_LIMIT"] = $PARAM_LIMIT;
        
        
        // Execute Stored Procedure
        // ...........................................
        $DATA_SET = PHPCUS_ADDON_RESOURCE::CUS_GET_MA($GET_MAP_ARRAY);
        
        
        // Return JSON response
        // ...........................................
        if(empty($DATA_SET) === False)
        {
            PHPCUS_PARAM::CUS_JSON_SUCCESS($DATA_SET);
        }
        else
        {
            PHPCUS_PARAM::CUS_JSON_SUCCESS('');
        }
        
    }
    Catch(Exception $ERR)
    {
        PHPVC_LOG::VAR_REPORT_ERROR($ERR, 0);
        PHPCUS_PARAM::CUS_JSON_ERROR($ERR->getMessage());
    }
}
else
{
    PHPCUS_PARAM::CUS_JSON_ERROR('Missing parameters');
}

?>